

const bundleJson = require('../bundle.json')
const { start } = require('./trace')

module.exports = (hpmApi) => {
  registI18nResource(hpmApi);
  const options = {
    description: hpmApi.i18n.getMessage(`${bundleJson.name}.description`),
    options: {
      "-j,--json": hpmApi.i18n.getMessage(`${bundleJson.name}.json`),
      "-o,--object <object>": hpmApi.i18n.getMessage(`${bundleJson.name}.object`),
      "-d,--depth <depth>": hpmApi.i18n.getMessage(`${bundleJson.name}.depth`),
    },
    args: '<name>'
  };
  hpmApi.registerCmd(
    'trace',
    options,
    (options, name, ...args) => {
      start(options, name, hpmApi).then((products) => {
        console.log(products);
      });
    },
    true
  )
}

function registI18nResource(hpmApi) {
  const en = {
    description: "Trace project dependencies",
    json: "Output in JSON format",
    depth: "The depth for tracking",
    object: "The object of tracking: product|bundle"
  };
  const zh = {
    description: "跟踪项目依赖",
    json: "输出为JSON格式",
    depth: "追踪的层级，默认",
    object: "追踪对象参数: product|bundle，默认为product"
  };

  hpmApi.i18n.addLocalization("en", en, { pluginName: bundleJson.name });
  hpmApi.i18n.addLocalization("zh", zh, { pluginName: bundleJson.name });
}