const {
  addonEvent,
  http
} = window.top.HPM_CLI_UI

var dom = document.getElementById("main");
var option;
var myChart;
addonEvent.subscribe('addonLoaded', async ({ name, isDarkMode }) => {
  http.get(`/resource/${name}/ui/data.json`).then((data) => {
    render(data, isDarkMode)
  }).catch(err => {
    console.log(err, 'err');
  })
}, true);

addonEvent.subscribe('themeChange', ({ isDarkMode }) => {
  setCurrentTheme(isDarkMode)
}, false) 

function setCurrentTheme(isDarkMode) {
  myChart.dispose();
  myChart = echarts.init(dom, isDarkMode ? 'dark' : 'light');
  myChart.setOption(option);
}

function render(data, isDarkMode = false) {
  // data[0].children.forEach(function (datum, index) {
  //   index % 2 === 0 && (datum.collapsed = true);
  // });
  myChart = echarts.init(dom, isDarkMode ? 'dark' : 'light');
  myChart.setOption(option = {
    tooltip: {
      trigger: 'item',
      triggerOn: 'mousemove'
    },
    series: [
      {
        type: 'tree',
        data,
        top: '1%',
        left: '20%',
        bottom: '1%',
        right: '20%',

        symbolSize: 10,

        label: {
          position: 'left',
          verticalAlign: 'middle',
          align: 'right',
          fontSize: 12
        },

        leaves: {
          label: {
            position: 'right',
            verticalAlign: 'middle',
            align: 'left'
          }
        },

        emphasis: {
          focus: 'descendant'
        },
        initialTreeDepth: 3, // 展开3层 ps:-1 null undefined 展开全部;不设置则适应展开
        expandAndCollapse: true,
        animationDuration: 550,
        animationDurationUpdate: 750
      }
    ]
  });

  if (option && typeof option === 'object') {
    myChart.setOption(option);
  }
}
